class s3 (
  Hash             $hiera_packages        = hiera_hash('s3::packages', {}),
  Hash             $hiera_files           = hiera_hash('s3::manage', {}),
  Boolean          $manageawscli          = true,
  Boolean          $enable_epel           = $s3::params::enable_epel,
  Boolean          $pippkg                = $s3::params::pippkg,
  String           $aws_cli_ini_settings  = $s3::params::aws_cli_ini_settings,
  String           $awscli                = $s3::params::awscli,
  String           $rubyjsonpkg           = $s3::params::rubyjsonpkg,
  String           $awscli_pkg            = $s3::params::awscli_pkg,
  Optional[String] $aws_access_key_id     = undef,
  Optional[String] $aws_secret_access_key = undef,
  ) inherits s3::params {

  if (!is_string($aws_access_key_id)) {
    fail('ERROR: ec2tagfacts::aws_access_key_id must be a string')
  }

  if (!is_string($aws_secret_access_key)) {
    fail('ERROR: ec2tagfacts::aws_secret_access_key must be a string')
  }

  if $enable_epel {
    include ::epel
  }

  if $manageawscli != false {

    if $pippkg != false {

      if $enable_epel {
        Class['epel'] -> Package[$pippkg]
      }

      package { $pippkg:
        ensure => 'installed',
      }

      package { $awscli:
        ensure   => 'installed',
        provider => $awscli_pkg,
        require  => Package[$pippkg],
    }

    } else {

      package { $awscli:
        ensure   => 'installed',
        provider => $awscli_pkg,
      }

    }

    if $rubyjsonpkg != undef {
      package { $rubyjsonpkg:
        ensure => 'installed',
        name   => $rubyjsonpkg,
      }
    }

  }



  if ($aws_secret_access_key != undef) and ($aws_access_key_id != undef) {

    $directory = dirname($aws_cli_ini_settings)

    file { $directory:
      ensure  => directory,
      require => Package[$awscli],
      recurse => true,
    }

    ini_setting { 'aws_access_key_id setting':
      ensure  => present,
      path    => $aws_cli_ini_settings,
      section => 'default',
      setting => 'aws_access_key_id',
      value   => $aws_access_key_id,
      require => File[$directory],
    }

    ini_setting { 'aws_secret_access_key setting':
      ensure  => present,
      path    => $aws_cli_ini_settings,
      section => 'default',
      setting => 'aws_secret_access_key',
      value   => $aws_secret_access_key,
      require => File[$directory],
    }

  }
  $hiera_packages.each |$name, $values| {
    s3::install {$name:
      * => $values
    }
  }
  $hiera_files.each |$name, $values| {
    s3::manage {$name:
      * => $values
    }
  }

}
