define s3::manage (
  String            $destination = '',
  String            $bucket      = '',
  Optional[String]  $source      = undef,
  String            $command     = 'cpbl',
  String            $flag        = '',
  Boolean           $refreshonly = true,
  Array             $path        = ['/usr/local/sbin', '/usr/local/bin', '/sbin:/bin', '/usr/sbin', '/usr/bin', '/opt/aws/bin', '/root/bin'],
)
{
  case $command {
    'cpbl': {
      exec { $title:
        path    => $path,
        command => "aws s3 cp s3://${bucket}${source} ${destination} ${flag}",
        unless  => "/bin/ls ${destination}${source}",
        }
    }
    'cplb': {
      exec { $title:
        path        => $path,
        command     => "aws s3 cp ${source} s3://${destination} ${flag}",
        refreshonly => $refreshonly,
        }
    }
    'cpbb': {
      exec { $title:
        path        => $path,
        command     => "aws s3 cp s3://${source} s3://${destination} ${flag}",
        refreshonly => $refreshonly,
        }
    }
    'mvbl': {
      exec { $title:
        path    => $path,
        command => "aws s3 mv s3://${bucket}${source} ${destination} ${flag}",
        unless  => "/bin/ls ${destination}${source}",
        }
    }
    'mvlb': {
      exec { $title:
        path        => $path,
        command     => "aws s3 mv ${source} s3://${destination} ${flag}",
        refreshonly => $refreshonly,
        }
    }
    'mvbb': {
      exec { $title:
        path        => $path,
        command     => "aws s3 mv s3://${source} s3://${destination} ${flag}",
        refreshonly => $refreshonly,
        }
    }
    'sybl': {
      exec { $title:
        path        => $path,
        command     => "aws s3 sync s3://${bucket}${source} ${destination} ${flag}",
        refreshonly => $refreshonly,
        }
    }
    'sylb': {
      exec { $title:
        path        => $path,
        command     => "aws s3 sync ${source} s3://${destination} ${flag}",
        refreshonly => $refreshonly,
        }
    }
    'sybb': {
      exec { $title:
        path        => $path,
        command     => "aws s3 sync s3://${source} s3://${destination} ${flag}",
        refreshonly => $refreshonly,
        }
    }
    'rm': {
      exec { $title:
        path    => $path,
        command => "aws s3 rm s3://${source} ${flag}",
        }
    }
    default: {
      notify {'error':
        message => 'The command entered is incorrect'
      }
    }
  }
}
