class s3::params {

  $aws_cli_ini_settings = '/root/.aws/credentials'

  case $::operatingsystem {
    'CentOS', 'RedHat' , 'OEL', 'OracleLinux': {
      $awscli       = 'awscli'
      $enable_epel  = true
      if ($::operatingsystemmajrelease + 0) >= (7 + 0) {
        $pippkg       = false
        $rubyjsonpkg  = 'rubygem-json'
        $awscli_pkg   = 'yum'
      } else {
        $pippkg       = 'python-pip'
        $rubyjsonpkg  = 'ruby-json'
        $awscli_pkg   = 'pip'
      }
    }
    'Fedora': {
      $awscli       = 'awscli'
      $enable_epel  = true
      if ($::operatingsystemmajrelease + 0) >= (22 + 0) {
        $pippkg       = false
        $rubyjsonpkg  = 'rubygem-json'
        $awscli_pkg   = 'yum'
      } else {
        $pippkg       = 'python-pip'
        $rubyjsonpkg  = 'ruby-json'
        $awscli_pkg   = 'pip'
      }
    }
    'Scientific', 'SLC', 'Ascendos', 'CloudLinux', 'PSBM', 'OVS': {
      $pippkg       = 'python-pip'
      $rubyjsonpkg  = 'ruby-json'
      $awscli       = 'awscli'
      $enable_epel  = true
      $awscli_pkg   = 'pip'
    }
    'Gentoo': {
      $pippkg       = false
      $rubyjsonpkg  = 'dev-ruby/json'
      $awscli       = 'aws-cli'
      $enable_epel  = false
      $awscli_pkg   = 'portage'
    }
    'Amazon': {
      $pippkg       = false
      $rubyjsonpkg  = 'rubygem18-json'
      $awscli       = 'aws-cli'
      $enable_epel  = false
      $awscli_pkg   = 'yum'
    }
    'ubuntu', 'debian': {
      $pippkg       = false
      $rubyjsonpkg  = 'ruby-json'
      $awscli       = 'awscli'
      $enable_epel  = false
      $awscli_pkg   = 'apt'
    }
    'SLES', 'SLED', 'OpenSuSE', 'SuSE': {
      $pippkg       = 'python-pip'
      $rubyjsonpkg  = 'ruby-json'
      $awscli       = 'awscli'
      $enable_epel  = false
      $awscli_pkg   = 'pip'
    }
    default: {
      fail("Unsupported platform: ${::osfamily}/${::operatingsystem}")
    }
  }

}
